unit UProjectManager;

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ComCtrls,
  UProject;

type

  { TProjectManager }

  TProjectManager = class(TForm)
    TreeViewProject: TTreeView;
    procedure TreeViewProjectChange(Sender: TObject; Node: TTreeNode);
  private
    procedure UpdateProjectGroup(Node: TTreeNode; Group: TProjectGroup);
  public
    procedure UpdateProjectTree;
  end;

var
  ProjectManager: TProjectManager;

implementation

{$R *.lfm}

uses
  UMainForm, UCodeForm, UCompiledForm, UCodeTreeForm, UProducerTreeView;

{ TProjectManager }

procedure TProjectManager.TreeViewProjectChange(Sender: TObject; Node: TTreeNode
  );
begin
  with MainForm, CodeForm do
  if Assigned(Node) then begin
    if TProjectNode(Node.Data) is TProjectFile then begin
      SynEditSource.Lines.Assign(TProjectFile(Node.Data).Source);
(*        if FileExists(TProjectFile(Node.Data).ProducedFileName) then
        CompiledForm.SynEdit1.Lines.LoadFromFile(FileName) else
          CompiledForm.SynEdit1.Lines.Clear;
        if ComboBoxTargetSelection.ItemIndex = 0 then
          CompiledForm.SynEdit1.Highlighter := CompiledForm.SynPasSyn1;
        if ComboBoxTargetSelection.ItemIndex = 1 then
          CompiledForm.SynEdit1.Highlighter := CompiledForm.SynCppSyn1;
        if ComboBoxTargetSelection.ItemIndex = 2 then
          CompiledForm.SynEdit1.Highlighter := nil;
        if ComboBoxTargetSelection.ItemIndex = 3 then
          CompiledForm.SynEdit1.Highlighter := CompiledForm.SynXMLSyn1;
  *)
      (*// Load code tree view
      Compiler.Producer.Free;
      Compiler.Producer := TProducerTreeView.Create;
      Compiler.Init;
      Compiler.Parser.OnGetSource := GetSource;
      with TProjectFile(Project.Items[0]) do begin
        Compiler.Compile(Parent.GetDir + Name, Source);
      end;
      //CodeTreeForm.TreeView1.Assign(TProducerTreeView(Compiler.Producer).TreeView);
      *)
    end;
  end;
end;

procedure TProjectManager.UpdateProjectTree;
var
  NewNode: TTreeNode;
begin
  with MainForm, TreeViewProject, Items do begin
    BeginUpdate;
    Clear;
    NewNode := AddChild(nil, Project.Name);
    UpdateProjectGroup(NewNode, Project);
    NewNode.Expand(True);
    EndUpdate;
    TreeViewProject.TopItem.Items[0].Selected := True;
  end;
end;

procedure TProjectManager.UpdateProjectGroup(Node: TTreeNode; Group: TProjectGroup);
var
  I: Integer;
  NewNode: TTreeNode;
begin
  with MainForm do
  for I := 0 to Group.Items.Count - 1 do begin
    NewNode := TreeViewProject.Items.AddChild(Node,
      TProjectNode(Group.Items[I]).Name);
    NewNode.Data := Pointer(Group.Items[I]);
    if TProjectNode(Group.Items[I]) is TProjectGroup then
      UpdateProjectGroup(NewNode, TProjectGroup(Group.Items[I]));
  end;
end;



end.

